INTERPOL = 1000

(n, m, k) = map(int, raw_input().split())

def f(g):
    rem = (n-g*k) % m
    val = ( g*(2*n - (g+m)*k) + (m+1)*n + rem*(rem-m) ) / 2
    return val

I = []

g = max(0, (n-(m-1)*(k-1))/k)
opt = 0
while g <= n/k:
    rem = (n-g*k) % m
    ng = g + max(min(rem/k, n/k-g), 1)
    I.append((g, ng))
    g = ng

tot_rem_points = sum(r-l-1 for (l, r) in I[:-1])
totL = I[-1][0] - I[0][0]
x = []
y = []
opt = [0]
opt_v = -1

for (x0, x1) in I:
    x.append(x0)
    y.append(f(x0))
    if y[-1] > opt_v:
        opt = []
        opt_v = y[-1]
    if y[-1] >= opt_v:
        opt.append(len(x)-1)

    if x1 > n/k: break

    rem_points = x1-x0-1
    if not rem_points: continue
    interpol_points = min(INTERPOL * (rem_points + tot_rem_points - 1) / (tot_rem_points), rem_points)

    for i in range(1, interpol_points+1):
        xmid = x0 + ((x1-x0)*i + interpol_points)/(interpol_points+1)
        if x[-1] < xmid < x1:
            x.append(xmid)
            y.append(f(xmid))


import sys
import matplotlib.pyplot as plt
from matplotlib.ticker import MaxNLocator

ax = plt.figure().gca()
ax.xaxis.set_major_locator(MaxNLocator(integer=True))

plt.plot(x, y, linewidth=1)
plt.plot([x[i] for i in opt], [y[i] for i in opt], 'ro')

fname = sys.argv[1] if len(sys.argv) > 1 else 'test.png'
plt.savefig(fname, bbox_inches='tight', dpi=150)

