#!/usr/bin/env python3
# Two events per child: each child plays with two toys, all switch at the same time.
# All children play with their first toy for 2 time units, the second for 1 time unit.
import sys
import random

seed = int(sys.argv[1])
random.seed(seed)

n = int(sys.argv[2])
m = int(sys.argv[3])

assert n <= m

event = []
A = list(range(n))
P1 = list(range(1, m+1))
random.shuffle(A)
random.shuffle(P1)
P2 = list(range(1, m+1))
random.shuffle(P2)
for k in range(n):
    while True:
        x = random.randint(k, m-1)
        if P2[x] != P1[k]:
            P2[k], P2[x] = P2[x], P2[k]
            break
for k in A:
    event += [(0, k+1, P1[k])]
for k in A:
    event += [(2, k+1, P2[k])]
print(f'{n} {m}')
print(f'3 {len(event)}')
for ev in event:
    print('%d %d %d' % ev)
